---
icon: material/new-box
---

!!! question "Since sing-box 1.12.0"

# Service

### Structure

```json
{
  "services": [
    {
      "type": "",
      "tag": ""
    }
  ]
}
```

### Fields

| Type              | Format                                |
|-------------------|---------------------------------------|
| `ccm`             | [CCM](./ccm)                          |
| `derp`            | [DERP](./derp)                        |
| `hysteria-realm`  | [Hysteria Realm](./hysteria-realm)    |
| `ocm`             | [OCM](./ocm)                          |
| `resolved`        | [Resolved](./resolved)                |
| `ssm-api`         | [SSM API](./ssm-api)                  |

#### tag

The tag of the endpoint.
